#include <math.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

int module(int a, int b)
{
    return b ? (a - (int)(a / b) * b) : a;
}

int gcd(int a, int b)
{
  cout << "gcd(" << a << ", " << b << ")\t[r = ";
  a = abs(a);
  b = abs(b);
  int r = module(a, b);
  cout << r << "]" << endl;
  return b ? gcd(b, r) : a;
}

int xgcd(int a, int b, int * s = NULL, int * t = NULL)
{
  if (b == 0)
  {
    if (s) *s = 1;
    if (t) *t = 0;
    return a;
  }
  
  int s1, t1;
  int d = xgcd(b, module(a, b), &s1, &t1);
  if (s) *s = t1;
  if (t) *t = s1 - (int)(a / b) * t1;
          
  return d;
}









/********************************************
 versione iterativa
*********************************************/

typedef struct v
{
  int k;
  int a, b;
  int q, r;
  int x, y;
} VECT;

void print(VECT v)
{
  cout << v.k << "\t" << v.a << "\t" << v.b << "\t" << v.q << "\t" << v.r << "\t" << v.x << "\t" << v.y <<  endl;  
}

VECT xgcdi(int a, int b)
{
  VECT v0, v1, v2;

  v2.k = 0; v2.a = 0; v2.b = 0; v2.q = 0; v2.r = 0; v2.x = 0; v2.y = 0;
  v1.k = 0; v1.a = 0; v1.b = 0; v1.q = 0; v1.r = 0; v1.x = 0; v1.y = 1;

  if (b == 0)
  {
    v0.k = 0; v0.a = a; v0.b = b; v0.x = 1; v0.y = 0;
    print(v0);
    return v0;
  }

  v0.k = 1; v0.a = a; v0.b = b; v0.q = a / b; v0.r = module(a, b); v0.x = 1; v0.y = 0;
  print(v0);
  
  while (v0.r != 0)
  {
    v2 = v1;
    v1 = v0;
    v0.k = v1.k + 1;
    v0.q = v1.b / v1.r; v0.r = module(v1.b, v1.r);
    v0.a = v1.b; v0.b = v1.r;
    v0.x = v2.x - v2.q * v1.x; v0.y = v2.y - v2.q * v1.y;  
    print(v0);
  }
  v2 = v1;
  v1 = v0;
  v0.k = v1.k + 1;
  v0.a = v1.b; v0.b = v1.r;
  v0.x = v2.x - v2.q * v1.x; v0.y = v2.y - v2.q * v1.y;
  cout << v0.k << "\t" << v0.a << "\t" << v0.b << "\t\t\t" << v0.x << "\t" << v0.y << endl;
  
  return v0;  
}

/********************************************
*********************************************/














int main()
{
  int a = 97, b = 18;
  
  cout << "gcd(" << a << "," << b << ")=" << gcd(a, b) << endl;

  cout << endl;
  
  int s, t;
  int d = xgcd(a, b, &s, &t);
  cout << "xgcd(" << a << "," << b << ")={" << d << "," << s << "," << t << "}" << endl;

  xgcdi(a, b);
  
  return 0;
}
